lev.gui

## Class LPanel

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.JPanel
        - - lev.gui.LPanel

- All Implemented Interfaces:
    java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, javax.accessibility.Accessible, javax.swing.Scrollable
  Direct Known Subclasses:
    LCenterPanel, LHelpPanel, LImagePane

      public class LPanel
      extends javax.swing.JPanel
      implements javax.swing.Scrollable

  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `LPanel.Align`

    - ### Nested classes/interfaces inherited from class javax.swing.JPanel

      `javax.swing.JPanel.AccessibleJPanel`

    - ### Nested classes/interfaces inherited from class javax.swing.JComponent

      `javax.swing.JComponent.AccessibleJComponent`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `java.awt.Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected LPanel.Align` | `align`
    `protected java.awt.Point` | `last` Reference to the position of the last-added setting or component added using Add() or AddSetting()
    `protected int` | `spacing` Spacing to be used between settings

    - ### Fields inherited from class javax.swing.JComponent

      `accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

    - ### Fields inherited from class java.awt.Component

      `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `LPanel()`
    `LPanel(int x, int y)`
    `LPanel(java.awt.Rectangle r)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `Add(java.awt.Component input)`
    `void` | `align(LPanel.Align align)`
    `java.awt.Dimension` | `getPreferredScrollableViewportSize()`
    `int` | `getScrollableBlockIncrement(java.awt.Rectangle visibleRect, int orientation, int direction)`
    `boolean` | `getScrollableTracksViewportHeight()`
    `boolean` | `getScrollableTracksViewportWidth()`
    `int` | `getScrollableUnitIncrement(java.awt.Rectangle visibleRect, int orientation, int direction)`
    `protected static java.awt.AlphaComposite` | `makeAlphaComposite(float alpha)` Creates an alpha composite with the given transparency.
    `void` | `placeAdd(java.awt.Component c)` Sets placement of the component and then adds it.
    `void` | `remeasure(java.awt.Dimension size)`
    `java.awt.Point` | `setPlacement(java.awt.Component c)` Sets the placement relative to the last component added.
    `java.awt.Point` | `setPlacement(java.awt.Component c, int x, int y)` Sets the placement to (x,y)
    `void` | `updateLast(java.awt.Component c)` Updates last GUI component tracker to be focused on c.

    - ### Methods inherited from class javax.swing.JPanel

      `getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

    - ### Methods inherited from class javax.swing.JComponent

      `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### last

          protected java.awt.Point last

      Reference to the position of the last-added setting or component added using Add() or AddSetting()

    - #### spacing

          protected int spacing

      Spacing to be used between settings

    - #### align

          protected LPanel.Align align

  - ### Constructor Detail

    - #### LPanel

          public LPanel()

    - #### LPanel

          public LPanel(java.awt.Rectangle r)

      Parameters:
        `r` -

    - #### LPanel

          public LPanel(int x,
                int y)

      Parameters:
        `x` -
        `y` -

  - ### Method Detail

    - #### Add

          public void Add(java.awt.Component input)

      Parameters:
        `input` -

    - #### getScrollableUnitIncrement

          public int getScrollableUnitIncrement(java.awt.Rectangle visibleRect,
                                       int orientation,
                                       int direction)

      Specified by:
        `getScrollableUnitIncrement` in interface `javax.swing.Scrollable`

    - #### getScrollableBlockIncrement

          public int getScrollableBlockIncrement(java.awt.Rectangle visibleRect,
                                        int orientation,
                                        int direction)

      Specified by:
        `getScrollableBlockIncrement` in interface `javax.swing.Scrollable`

    - #### getScrollableTracksViewportWidth

          public boolean getScrollableTracksViewportWidth()

      Specified by:
        `getScrollableTracksViewportWidth` in interface `javax.swing.Scrollable`

    - #### getScrollableTracksViewportHeight

          public boolean getScrollableTracksViewportHeight()

      Specified by:
        `getScrollableTracksViewportHeight` in interface `javax.swing.Scrollable`

    - #### getPreferredScrollableViewportSize

          public java.awt.Dimension getPreferredScrollableViewportSize()

      Specified by:
        `getPreferredScrollableViewportSize` in interface `javax.swing.Scrollable`

    - #### remeasure

          public void remeasure(java.awt.Dimension size)

      Parameters:
        `size` -

    - #### makeAlphaComposite

          protected static java.awt.AlphaComposite makeAlphaComposite(float alpha)

      Creates an alpha composite with the given transparency.
      Parameters:
        `alpha` -
      Returns:

    - #### setPlacement

          public java.awt.Point setPlacement(java.awt.Component c)

      Sets the placement relative to the last component added.
      Parameters:
        `c` -
      Returns:
        The point the component was placed

    - #### setPlacement

          public java.awt.Point setPlacement(java.awt.Component c,
                                    int x,
                                    int y)

      Sets the placement to (x,y)
      Parameters:
        `c` -
        `x` -
        `y` -
      Returns:
        The point the component was placed

    - #### placeAdd

          public void placeAdd(java.awt.Component c)

      Sets placement of the component and then adds it.
      Parameters:
        `c` -

    - #### align

          public void align(LPanel.Align align)

      Parameters:
        `align` -

    - #### updateLast

          public void updateLast(java.awt.Component c)

      Updates last GUI component tracker to be focused on c. For use with setPlacement()
      Parameters:
        `c` - Component to set as the last GUI component placed.